
_Send_LED_Data:

;Konami_Drivers.mbas,119 :: 		j as byte
;Konami_Drivers.mbas,121 :: 		for i = Words to 1 step -1                      'Do requested word count
	MOVF        FARG_Send_LED_Data_Words+0, 0 
	MOVWF       R4 
	MOVLW       1
	SUBWF       FARG_Send_LED_Data_Words+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Send_LED_Data5
L__Send_LED_Data2:
;Konami_Drivers.mbas,122 :: 		for j = Bits to 1 step -1                     'Do Requested bits per word MSB first
	MOVF        FARG_Send_LED_Data_Bits+0, 0 
	MOVWF       R5 
	MOVLW       1
	SUBWF       FARG_Send_LED_Data_Bits+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__Send_LED_Data10
L__Send_LED_Data7:
;Konami_Drivers.mbas,123 :: 		LED_Data = Test_Data.(j-1)                   'Set the data bit
	DECF        R5, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       R2 
	MOVLW       1
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L__Send_LED_Data52:
	BZ          L__Send_LED_Data53
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__Send_LED_Data52
L__Send_LED_Data53:
	MOVF        R0, 0 
	ANDWF       _Test_Data+0, 0 
	MOVWF       R2 
	MOVF        _Test_Data+1, 0 
	ANDWF       R1, 0 
	MOVWF       R3 
	CLRF        R1 
	MOVLW       0
	XORWF       R3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Send_LED_Data54
	MOVLW       0
	XORWF       R2, 0 
L__Send_LED_Data54:
	BTFSC       STATUS+0, 2 
	GOTO        L__Send_LED_Data11
	MOVLW       1
	MOVWF       R1 
L__Send_LED_Data11:
	BTFSC       R1, 0 
	GOTO        L__Send_LED_Data55
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
	GOTO        L__Send_LED_Data56
L__Send_LED_Data55:
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
L__Send_LED_Data56:
;Konami_Drivers.mbas,124 :: 		LED_Clock = 1                                'clock it in
	BSF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;Konami_Drivers.mbas,125 :: 		LED_Clock = 0                                'and drop our clock
	BCF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;Konami_Drivers.mbas,126 :: 		next j
	MOVF        R5, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L__Send_LED_Data10
	MOVLW       255
	ADDWF       R5, 1 
	GOTO        L__Send_LED_Data7
L__Send_LED_Data10:
;Konami_Drivers.mbas,127 :: 		next i
	MOVF        R4, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L__Send_LED_Data5
	MOVLW       255
	ADDWF       R4, 1 
	GOTO        L__Send_LED_Data2
L__Send_LED_Data5:
;Konami_Drivers.mbas,128 :: 		If Latch_Flag
	MOVF        FARG_Send_LED_Data_Latch_Flag+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Send_LED_Data13
;Konami_Drivers.mbas,130 :: 		LED_Latch = 1                               'Raise Latch Enable
	BSF         LATC2_bit+0, BitPos(LATC2_bit+0) 
;Konami_Drivers.mbas,131 :: 		LED_Latch = 0                               'and drop the latch
	BCF         LATC2_bit+0, BitPos(LATC2_bit+0) 
L__Send_LED_Data13:
;Konami_Drivers.mbas,133 :: 		end sub
L_end_Send_LED_Data:
	RETURN      0
; end of _Send_LED_Data

_Flash:

;Konami_Drivers.mbas,135 :: 		sub procedure Flash
;Konami_Drivers.mbas,137 :: 		Test_Data_Save = Test_Data                     'Save what were doing
	MOVF        _Test_Data+0, 0 
	MOVWF       _Test_Data_Save+0 
	MOVF        _Test_Data+1, 0 
	MOVWF       _Test_Data_Save+1 
;Konami_Drivers.mbas,138 :: 		Test_Data = Off
	CLRF        _Test_Data+0 
	CLRF        _Test_Data+1 
;Konami_Drivers.mbas,139 :: 		Send_LED_DATA (Three_Words * Num_Of_Boards,Four_Nibbles, Latch)
	MOVLW       9
	MOVWF       FARG_Send_LED_Data_Words+0 
	MOVLW       16
	MOVWF       FARG_Send_LED_Data_Bits+0 
	MOVLW       1
	MOVWF       FARG_Send_LED_Data_Latch_Flag+0 
	CALL        _Send_LED_Data+0, 0
;Konami_Drivers.mbas,140 :: 		Test_Data = Test_Data_Save
	MOVF        _Test_Data_Save+0, 0 
	MOVWF       _Test_Data+0 
	MOVF        _Test_Data_Save+1, 0 
	MOVWF       _Test_Data+1 
;Konami_Drivers.mbas,141 :: 		end sub
L_end_Flash:
	RETURN      0
; end of _Flash

_All_LEDs_OFF:

;Konami_Drivers.mbas,143 :: 		sub procedure All_LEDs_OFF
;Konami_Drivers.mbas,145 :: 		Test_Data = OFF                                'Turn OFF all LED's
	CLRF        _Test_Data+0 
	CLRF        _Test_Data+1 
;Konami_Drivers.mbas,146 :: 		Send_LED_Data (Three_words * Num_Of_Boards,Four_Nibbles, Latch)   'Send the full count of Test_Data
	MOVLW       9
	MOVWF       FARG_Send_LED_Data_Words+0 
	MOVLW       16
	MOVWF       FARG_Send_LED_Data_Bits+0 
	MOVLW       1
	MOVWF       FARG_Send_LED_Data_Latch_Flag+0 
	CALL        _Send_LED_Data+0, 0
;Konami_Drivers.mbas,148 :: 		end sub
L_end_All_LEDs_OFF:
	RETURN      0
; end of _All_LEDs_OFF

_Delay_For_Key:

;Konami_Drivers.mbas,150 :: 		sub Procedure Delay_For_Key (dim Time as word)          'Wait Requested Timeds or a Key E.0 Press
;Konami_Drivers.mbas,151 :: 		for Key_Timer = 0 to Time                      'This will be @ 1.5 secondas
	CLRF        _Key_Timer+0 
	CLRF        _Key_Timer+1 
L__Delay_For_Key18:
	MOVF        _Key_Timer+1, 0 
	SUBWF       FARG_Delay_For_Key_Time+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Delay_For_Key60
	MOVF        _Key_Timer+0, 0 
	SUBWF       FARG_Delay_For_Key_Time+0, 0 
L__Delay_For_Key60:
	BTFSS       STATUS+0, 0 
	GOTO        L__Delay_For_Key22
;Konami_Drivers.mbas,152 :: 		delay_ms (2)                               'of 2 ms + time to read key
	MOVLW       6
	MOVWF       R12, 0
	MOVLW       48
	MOVWF       R13, 0
L__Delay_For_Key23:
	DECFSZ      R13, 1, 1
	BRA         L__Delay_For_Key23
	DECFSZ      R12, 1, 1
	BRA         L__Delay_For_Key23
	NOP
;Konami_Drivers.mbas,153 :: 		if BUTTON (PORTE, 0, 5, 1)                 'Look for the press
	MOVLW       PORTE+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTE+0)
	MOVWF       FARG_Button_port+1 
	CLRF        FARG_Button_pin+0 
	MOVLW       5
	MOVWF       FARG_Button_time+0 
	MOVLW       1
	MOVWF       FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Delay_For_Key25
;Konami_Drivers.mbas,155 :: 		While Button (PORTE, 0, 5, 1)            'Got a press wait for it to be released
L__Delay_For_Key28:
	MOVLW       PORTE+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTE+0)
	MOVWF       FARG_Button_port+1 
	CLRF        FARG_Button_pin+0 
	MOVLW       5
	MOVWF       FARG_Button_time+0 
	MOVLW       1
	MOVWF       FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Delay_For_Key29
;Konami_Drivers.mbas,156 :: 		nop
	NOP
;Konami_Drivers.mbas,157 :: 		Wend
	GOTO        L__Delay_For_Key28
L__Delay_For_Key29:
;Konami_Drivers.mbas,158 :: 		Key = 1                                  'Return the keypress
	MOVLW       1
	MOVWF       _Key+0 
;Konami_Drivers.mbas,159 :: 		exit                                     'bugger off
	GOTO        L_end__Delay_For_Key
L__Delay_For_Key25:
;Konami_Drivers.mbas,161 :: 		if BUTTON (PORTE, 1, 5, 1)                  'Look for the press of E.1
	MOVLW       PORTE+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTE+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       1
	MOVWF       FARG_Button_pin+0 
	MOVLW       5
	MOVWF       FARG_Button_time+0 
	MOVLW       1
	MOVWF       FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Delay_For_Key33
;Konami_Drivers.mbas,163 :: 		While Button (PORTE, 1, 5, 1)            'Got a press wait for it to be released
L__Delay_For_Key36:
	MOVLW       PORTE+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTE+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       1
	MOVWF       FARG_Button_pin+0 
	MOVLW       5
	MOVWF       FARG_Button_time+0 
	MOVLW       1
	MOVWF       FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__Delay_For_Key37
;Konami_Drivers.mbas,164 :: 		nop
	NOP
;Konami_Drivers.mbas,165 :: 		Wend
	GOTO        L__Delay_For_Key36
L__Delay_For_Key37:
;Konami_Drivers.mbas,166 :: 		Key = 2                                  'Return the keypress of E.1
	MOVLW       2
	MOVWF       _Key+0 
;Konami_Drivers.mbas,167 :: 		exit                                     'bugger off
	GOTO        L_end__Delay_For_Key
L__Delay_For_Key33:
;Konami_Drivers.mbas,169 :: 		next Key_Timer
	MOVF        _Key_Timer+1, 0 
	XORWF       FARG_Delay_For_Key_Time+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__Delay_For_Key61
	MOVF        FARG_Delay_For_Key_Time+0, 0 
	XORWF       _Key_Timer+0, 0 
L__Delay_For_Key61:
	BTFSC       STATUS+0, 2 
	GOTO        L__Delay_For_Key22
	INFSNZ      _Key_Timer+0, 1 
	INCF        _Key_Timer+1, 1 
	GOTO        L__Delay_For_Key18
L__Delay_For_Key22:
;Konami_Drivers.mbas,170 :: 		Key = 0                                        'Flag no key
	CLRF        _Key+0 
;Konami_Drivers.mbas,171 :: 		end sub
L_end__Delay_For_Key:
L_end_Delay_For_Key:
	RETURN      0
; end of _Delay_For_Key

_Write_LED_Array:

;Konami_Drivers.mbas,175 :: 		dim Word_Counter as byte
;Konami_Drivers.mbas,177 :: 		for Board_Counter = Num_Of_Boards to 1 step -1'Send all installed boards
	MOVLW       3
	MOVWF       Write_LED_Array_Board_Counter+0 
L__Write_LED_Array42:
;Konami_Drivers.mbas,178 :: 		for Word_Counter = 2 to 0 step -1           'Three words per board
	MOVLW       2
	MOVWF       Write_LED_Array_Word_Counter+0 
L__Write_LED_Array47:
;Konami_Drivers.mbas,179 :: 		Test_Data = Board_Data [Board_Counter -1 ] [Word_Counter]
	DECF        Write_LED_Array_Board_Counter+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       6
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16x16_U+0, 0
	MOVLW       _Board_Data+0
	ADDWF       R0, 0 
	MOVWF       R3 
	MOVLW       hi_addr(_Board_Data+0)
	ADDWFC      R1, 0 
	MOVWF       R4 
	MOVF        Write_LED_Array_Word_Counter+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R3, 0 
	MOVWF       FSR0 
	MOVF        R1, 0 
	ADDWFC      R4, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       _Test_Data+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       _Test_Data+1 
;Konami_Drivers.mbas,180 :: 		Send_LED_Data (One_word ,Four_Nibbles,No_Latch)    'Send the Data for Board 1
	MOVLW       1
	MOVWF       FARG_Send_LED_Data_Words+0 
	MOVLW       16
	MOVWF       FARG_Send_LED_Data_Bits+0 
	CLRF        FARG_Send_LED_Data_Latch_Flag+0 
	CALL        _Send_LED_Data+0, 0
;Konami_Drivers.mbas,181 :: 		next word_counter
	MOVF        Write_LED_Array_Word_Counter+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__Write_LED_Array50
	MOVLW       255
	ADDWF       Write_LED_Array_Word_Counter+0, 1 
	GOTO        L__Write_LED_Array47
L__Write_LED_Array50:
;Konami_Drivers.mbas,182 :: 		next Board_Counter
	MOVF        Write_LED_Array_Board_Counter+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L__Write_LED_Array45
	MOVLW       255
	ADDWF       Write_LED_Array_Board_Counter+0, 1 
	GOTO        L__Write_LED_Array42
L__Write_LED_Array45:
;Konami_Drivers.mbas,183 :: 		LED_Latch = 1
	BSF         LATC2_bit+0, BitPos(LATC2_bit+0) 
;Konami_Drivers.mbas,184 :: 		LED_Latch = 0
	BCF         LATC2_bit+0, BitPos(LATC2_bit+0) 
;Konami_Drivers.mbas,185 :: 		end sub
L_end_Write_LED_Array:
	RETURN      0
; end of _Write_LED_Array
